//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Ac97.h"
#include "dos.h"

USERES("ac97live.res");
USEFORM("ac97gui.cpp", MainForm);
USEUNIT("Ac97.cpp");
//---------------------------------------------------------------------------

bool PreWindow( void );

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    try
    {
         Application->Initialize();
         Ac97::TraceClear();
         if( !PreWindow() )
         {
            Application->Title = "AC97 SoundBlaster Live! Tool";
            Application->CreateForm(__classid(TMainForm), &MainForm);
            Application->Run();
         }

    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}

bool PreWindow( void )
{
    // init codec
    Ac97::DetectSBLive();

    // parameters?
    if( _argv[ 1 ] )
    {
        // don't reset mixer?
        if( strstr( strupr(_argv[ 1 ]), "NO_RESET" ) == NULL )
        {
            Ac97::Reset();
        }

        // go away?
        if( strstr( strupr(_argv[ 1 ]), "NO_GUI" ) )
        {
            return true;
        }
    }
    else
    {
        // no parameters, reset is mandatory!
        Ac97::Reset();
    }

    return false;
}
//---------------------------------------------------------------------------
